Subject: Re: Kernel oops on setting sky2 interfaces down

From: Stephen Hemminger <[email-masked]>
Date: Thu, 23 Jul 2009 10:28:48 -0700

On Tue, 21 Jul 2009 18:26:39 +0200
Rene Mayrhofer <[email-masked]> wrote:

> Hi everybody,
> 
> [Please CC me in replies, I am not currently subscribed to this list.]
> 
> I have a fully reproducible kernel oops in the sky2 module in kernel
> 2.6.28.10. The kernel is a vanilla 2.6.28.10 (and I can't switch to
> anything newer at this time because of missing squashfs-lzma support),
> patched with PaX, netfilter-layer7, squashfs (with LZMA), and IMQ. The
> base system is a Debian Lenny with some updates from testing/unstable.
> 
> Whenever interfaces using the sky2 module (this box has 8 network
> interfaces in a 19" rack appliance) go down, the oops occurs:
> 

You could try commenting out sky2_shutdown which does the Wol
power down stuff. Maybe changing setting of Wake On Lan would
help as well.

What happens if you take interface down 'ip link set eth0 down' (or ifconfig)?

There are several different register writes in the shutdown path.
You could add code to check if a particular access is disabling
the PCI buss with:

    sky2_write(... som register...)
    BUG_ON(sky2_read16(sky2->hw, B0_CTST) == 0xffff);

--